using BasePaySdk.Request;
using BasePaySdk;
using JiaZhiQuan.Common.Config;
using Newtonsoft.Json;
using System.Collections.Generic;
using System;
using Newtonsoft.Json.Linq;
using Wicture.DbRESTFul;

namespace JiaZhiQuan.Common.JuheAPI.HuiFu {
    public class HuiFuApiIndv {
        //基本开户
        public static BaseRequest InitReq(HuiFuCommonConfig huifuConf,
            HuiFuIndvInfo info) {
            // 2.组装请求参数
            V2UserBasicdataIndvRequest request = new V2UserBasicdataIndvRequest();
            // 请求流水号
            request.setReqSeqId(info.reqId);
            // 请求日期
            request.setReqDate(DateTime.Now.ToString("yyyyMMdd"));
            // 个人姓名
            request.setName(info.name);
            // 个人证件类型
            request.setCertType("00");
            // 个人证件号码
            request.setCertNo(info.cert_no);
            // 个人证件有效期类型
            request.setCertValidityType(info.cert_validity_type);
            // 个人证件有效期开始日期
            request.setCertBeginDate(info.cert_begin_date);
            // 手机号
            request.setMobileNo(info.mobile_no);
            // 地址开通中信E管家必填
            // request.setAddress("test");

            // 设置非必填字段
            Dictionary<string, object> extendInfoMap = getExtendInfos(huifuConf, info);
            request.setExtendInfo(extendInfoMap);
            return request;
        }

        /**
         * 非必填字段
         * @return
         */
        private static Dictionary<string, object> getExtendInfos(HuiFuCommonConfig huifuConf,
            HuiFuIndvInfo info) {
            // 设置非必填字段
            Dictionary<string, object> extendInfoMap = new Dictionary<string, object>();
            // 个人证件有效期截止日期
            //extendInfoMap.Add("cert_end_date", info.cert_end_date);
            // 电子邮箱
            //extendInfoMap.Add("email", "jeff.peng@huifu.com");
            // 管理员账号
            //extendInfoMap.Add("login_name", "Lg2022022201394910571");
            // 是否发送短信标识
            //extendInfoMap.Add("sms_send_flag", "1");
            // 拓展方字段
            //extendInfoMap.Add("expand_id", "");
            // 文件列表
            //extendInfoMap.Add("file_list", getFileList());
            return extendInfoMap;
        }

        private static string getFileList() {
            Dictionary<string, object> obj = new Dictionary<string, object>();
            // 文件类型
            obj.Add("file_type", "F04");
            // 文件jfileID
            obj.Add("file_id", "2022022201394949297117211");
            // 文件名称
            obj.Add("file_name", "企业营业执照1.jpg");

            JArray objList = new JArray();
            objList.Add(JToken.FromObject(obj));
            return JsonConvert.SerializeObject(objList);
        }
    }
}
